<template>
  <div
    :style="{width:props.dimensions.width+'px',height:props.dimensions.height+'px'}">
    <NodeResizer :min-width="96 / 2.54/2" :min-height="96 / 2.54/2" :max-width="pageSize.width"
                 :max-height="pageSize.height" color="#000"
                 v-if="!props.isView && !props.isHideHandle && props.selected" />

    <div class="custom-node"
         :style="{...border(),textAlign:props.data.options.horizontalAlign,width:props.dimensions.width+'px',lineHeight:props.dimensions.height+'px',height:props.dimensions.height+'px',pointerEvents:props.isView?'auto': 'none',}">
      <span
        v-if="eleData"
        :style="{color:props.data.options.color,fontSize:props.dimensions.height+'px'}">
        {{ eleData }}
      </span>
    </div>
  </div>
</template>
<script setup>
import { defineProps } from 'vue';
import { NodeResizer } from '@vue-flow/node-resizer';

const props = defineProps({
  isView: {
    type: Boolean,
    required: false
  },
  isHideHandle: {
    type: Boolean,
    required: false
  },
  selected: {
    type: Boolean,
    required: false
  },
  data: {
    type: Object,
    required: true
  },
  dimensions: {
    type: Object,
    required: true
  },
  pageSize: {
    type: Object,
    required: true
  },
  pageData: {
    type: Object,
    required: true
  }
});
const eleData = ref('');
const getEleData = () => {
  if (props.isView) {
    eleData.value = props.data.options.field ? props.pageData?.[props.data.options.field] : props.data.options.default;
  } else {
    eleData.value = props.data.options.default || '文字';
  }
};
onMounted(() => {
  getEleData();
});
watch(() => JSON.parse(JSON.stringify(props.data.options.default)), (obj1, obj2) => {
  if (JSON.stringify(obj1) !== JSON.stringify(obj2)) {
    getEleData();
  }
}, { deep: true });
const border = () => {
  let res = {};
  if (props.data.options.border) {
    let top = props.data.options.border.find(e => e.type === 'top');
    let right = props.data.options.border.find(e => e.type === 'right');
    let bottom = props.data.options.border.find(e => e.type === 'bottom');
    let left = props.data.options.border.find(e => e.type === 'left');
    if (top.isShow) {
      res['borderTop'] = `${top.width}px ${top.borderType} ${top.color}`;
    }
    if (right.isShow) {
      res['borderRight'] = `${right.width}px ${right.borderType} ${right.color}`;
    }
    if (bottom.isShow) {
      res['borderBottom'] = `${bottom.width}px ${bottom.borderType} ${bottom.color}`;
    }
    if (left.isShow) {
      res['borderLeft'] = `${left.width}px ${left.borderType} ${left.color}`;
    }
  }
  return res;
};
</script>
<style scoped>
.custom-node {
  position: absolute;
}
</style>

